Name: troll-ftpd
Version: 1.22
Release: 5
Copyright: freeware
URL: http://www.troll.no/freebies/ftpd.html
Source0: ftp://ftp.troll.no/freebies/ftpd/troll-ftpd-1.22.tar.gz
Source1: mkusers.cron
Source2: ftplockout
Patch0: troll-ftpd-1.22-glibc.patch
Patch1: troll-ftpd-1.22-pam.patch
Patch2: troll-ftpd-1.22-location.patch
Patch3: troll-ftpd-1.22-xcommands.patch
Patch4: troll-ftpd-1.22-manpage.patch
Patch5: troll-ftpd-1.22-chown.patch
Group: Networking/Daemons
Provides: ftpserver
Conflicts: wu-ftpd, anonftp
BuildRoot: /tmp/troll-ftpd-root/
Summary: A small, more secure FTP daemon

%description
This is Troll Tech's freeware FTPd. It's designed to be small, use less
resources, and to not execute external programs. It supports only the most-used
features and commands of FTP, leaves out depreciated or meaningless commands,
and anything that correlates with trouble.

It supports virtual hosts, FTP-only accounts, anonymous FTP, and suspension of
downloads after a certain load average is reached. This version has been
PAMified for your protection.

%changelog
* Sun Dec 20 1998 Sergey Clushin <serg@aviacom.ru>
- Ability to build by non-root
- The %post and %postun scripts remove tftp from inetd.conf - fixed
- The %preun script cleans /var/ftp directory

* Mon Jan 12 1998 Scott Lampert <fortunato@heavymetal.org>
- Changed RPM to include pre-built ftplockout file
- Modified man page to include documentation on some of the
  changes from the standard distribution (namely PAM stuff)

* Wed Jan 07 1998 Scott Lampert <fortunato@heavymetal.org>
- Made changes and added necessary includes for compilation under glibc
- fixed a #define change (PAM_CRED_ESTABLISH is now PAM_ESTABLISH_CRED)
  in log_pam.c 

* Sat Nov 1 1997 Ximenes Zalteca <ximenes@mythic.net> 1.22-2
- Added support for XPWD, XRMD, and XMKD (treated exactely like PWD, RMD, 
  and MKD). This is necessary for at least the FTP.EXE that ships with Windows
  95, and possibly for other "broken" clients.

* Tue Oct 7 1997 Ximenes Zalteca <ximenes@mythic.net> 1.22-1
- Updated to 1.22
- Added PAM support, thanks to Kelley L. <redhat@cococo.net>

* Tue Aug 26 1997 Ximenes Zalteca <ximenes@mythic.net> 1.21-1
- Initial release

%prep
%setup
%patch0 -p1 
%patch1
%patch2
%patch3
%patch4 -p1
%patch5

%build
make RPM_OPT_FLAGS="${RPM_OPT_FLAGS}"
strip ftpd mkusers

%install
rm -rf ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}/etc/pam.d/
mkdir -p ${RPM_BUILD_ROOT}/var/ftp/
mkdir -p ${RPM_BUILD_ROOT}/usr/sbin/
mkdir -p ${RPM_BUILD_ROOT}/usr/man/man8/
make install RPM_BUILD_ROOT="${RPM_BUILD_ROOT}"
mkdir -p ${RPM_BUILD_ROOT}/etc/cron.daily/
install -c ${RPM_SOURCE_DIR}/mkusers.cron ${RPM_BUILD_ROOT}/etc/cron.daily/
install -c ${RPM_SOURCE_DIR}/ftplockout ${RPM_BUILD_ROOT}/etc

%post
/usr/sbin/mkusers

if [ `grep -i Troll /etc/inetd.conf | wc -l` = 0 ]
then
	awk '
		$0 ~ "End of inetd.conf" { next; }
		$0 ~ "^#" { print; next; }
		$7 == "ftpd" || $7 == "in.ftpd" { print "#", $0; next; }
		{ print; }
	' /etc/inetd.conf > /etc/inetd.conf.new
	echo "#" >> /etc/inetd.conf.new
	echo "# Troll FTPd" >> /etc/inetd.conf.new
	echo "#" >> /etc/inetd.conf.new
	echo "ftp  stream  tcp     nowait  root  /usr/sbin/tcpd /usr/sbin/ftpd" >> /etc/inetd.conf.new
	echo >> /etc/inetd.conf.new
	echo "# End of inetd.conf" >> /etc/inetd.conf.new
	mv /etc/inetd.conf.new /etc/inetd.conf
fi

[ -f /var/run/inetd.pid ] && kill -HUP `cat /var/run/inetd.pid`

%preun
[ "$1" = "0" ] && rm -r /var/ftp/{users,groups}

%postun
if [ "$1" = "0" ]
then
	awk '
		$0 ~ "Troll" { next; }
		$0 ~ "^#" { print; next; }
		$1 == "ftp" && $7 == "/usr/sbin/ftpd" { next; }
		{ print; }
	' /etc/inetd.conf > /etc/inetd.conf.new
	mv /etc/inetd.conf.new /etc/inetd.conf
fi

[ -f /var/run/inetd.pid ] && kill -HUP `cat /var/run/inetd.pid`

%clean
rm -rf ${RPM_BUILD_ROOT}

%files
%attr(755, root, root) %dir /var/ftp/
%attr(-, root, root) %doc COPYING README
%attr(-, root, root) /usr/man/man8/ftpd.8
%attr(-, root, root) /usr/sbin/ftpd
%attr(-, root, root) /usr/sbin/mkusers
%attr(0644, root, root) %config /etc/pam.d/ftp
%attr(0755, root, root) %config /etc/cron.daily/mkusers.cron
%attr(0600, root, root) %config /etc/ftplockout
